#!/bin/csh
# usage : ac.fs half_space_AC_dir. [-,+][x,y,z] full_space_AC_dir.
#
set tmp=/tmp/ac.fs.$$
#
if ($#argv != 3) then
  stderr 'usage : ac.fs half_space_AC_dir. [-,+][x,y,z] full_space_AC_dir.'
  exit 1
endif
#
set hsd=$argv[1]
set fsd=$argv[3]
#
foreach dir ($hsd $fsd)
  if (!(-d $dir)) then
    stderr $dir : directory not found. ; exit 1
  endif
end
#
set pnc=(`slicePNC $hsd -`) ; if ($#pnc != 4) exit 1
#
switch($argv[2])
  case -x :
    @ x1 = 0 ; @ y1 = 0 ; @ x2 = $pnc[1] - 1 ; @ y2 = 0 ; @ z =  0 ; breaksw
  case +x :
    @ x1 = $pnc[1] - 1 ; @ y1 = 0 ; @ x2 = 0 ; @ y2 = 0 ; @ z =  0 ; breaksw
  case -y :
    @ x1 = 0 ; @ y1 = 0 ; @ x2 = 0 ; @ y2 = $pnc[2] - 1 ; @ z =  0 ; breaksw
  case +y :
    @ x1 = 0 ; @ y1 = $pnc[2] - 1 ; @ x2 = 0 ; @ y2 = 0 ; @ z =  0 ; breaksw
  case -z :
                                                          @ z = -1 ; breaksw
  case +z :
                                                          @ z =  1 ; breaksw
  default :
    stderr $argv[2] : bad half space. ; exit 1
endsw
#
if ($z == 0) then
  set tiff=(`ls $hsd`)
  @ x = $pnc[1] + ( $x1 + $x2 )
  @ y = $pnc[2] + ( $y1 + $y2 )
  set awk=('{ printf sprintf("%%0%dd.tif\n",length(' $pnc[3] '-1)),$1 }')
  while ($z < $pnc[3])
    @ z0 = $z + 1
    set tiff0=${hsd}/$tiff[$z0]
    @ zz = $pnc[3] - $z ; tiffrar ${hsd}/$tiff[$zz] -x -y $tmp
    ( echo $tiff0 $x1 $y1 ; echo $tmp $x2 $y2 ) | tiffpaste $x $y 1 $tmp
    tiffdesc $tmp "`tiffdesc $tiff0`" ${fsd}/`echo $z | awk "$awk"` ; rm $tmp
    @ z = $z0
  end
else
  set awk=('{ printf sprintf("%%0%dd.tif\n",length(' $pnc[3] '*2-2)),$1 }')
  if ($z == -1) then
    @ z = 0
    foreach tiff (`ls $hsd`)
      cp ${hsd}/$tiff ${fsd}/`echo $z | awk "$awk"` ; @ z += 1
    end
    foreach tiff (`ls -r $hsd | tail -n +2`)
      tiffrar ${hsd}/$tiff -x -y ${fsd}/`echo $z | awk "$awk"` ; @ z += 1
    end
  else
    @ z = 0
    foreach tiff (`ls -r $hsd`)
      tiffrar ${hsd}/$tiff -x -y ${fsd}/`echo $z | awk "$awk"` ; @ z += 1
    end
    foreach tiff (`ls $hsd | tail -n +2`)
      cp ${hsd}/$tiff ${fsd}/`echo $z | awk "$awk"` ; @ z += 1
    end
  endif
endif
