#!/bin/csh
# usage : ac.hs full_space_AC_dir. [-,+][x,y,z] half_space_AC_dir.
#
if ($#argv != 3) then
  stderr 'usage : ac.hs full_space_AC_dir. [-,+][x,y,z] half_space_AC_dir.'
  exit 1
endif
#
set fsd=$argv[1]
set hsd=$argv[3]
#
foreach dir ($fsd $hsd)
  if (!(-d $dir)) then
    stderr $dir : directory not found. ; exit 1
  endif
end
#
set pnc=(`slicePNC $fsd -`) ; if ($#pnc != 4) exit 1
#
switch($argv[2])
  case -x :
    @ x1 = 0 ; @ x2 = $pnc[1] / 2
    @ y1 = 0 ; @ y2 = $pnc[2] - 1
    @ z1 = 0 ; @ z2 = $pnc[3] - 1 ; breaksw
  case -y :
    @ x1 = 0 ; @ x2 = $pnc[1] - 1
    @ y1 = 0 ; @ y2 = $pnc[2] / 2
    @ z1 = 0 ; @ z2 = $pnc[3] - 1 ; breaksw
  case -z :
    @ x1 = 0 ; @ x2 = $pnc[1] - 1
    @ y1 = 0 ; @ y2 = $pnc[2] - 1
    @ z1 = 0 ; @ z2 = $pnc[3] / 2 ; breaksw
  case +x :
    @ x1 = $pnc[1] / 2 ; @ x2 = $pnc[1] - 1
    @ y1 = 0           ; @ y2 = $pnc[2] - 1
    @ z1 = 0           ; @ z2 = $pnc[3] - 1 ; breaksw
  case +y :
    @ x1 = 0           ; @ x2 = $pnc[1] - 1
    @ y1 = $pnc[2] / 2 ; @ y2 = $pnc[2] - 1
    @ z1 = 0           ; @ z2 = $pnc[3] - 1 ; breaksw
  case +z :
    @ x1 = 0           ; @ x2 = $pnc[1] - 1
    @ y1 = 0           ; @ y2 = $pnc[2] - 1
    @ z1 = $pnc[3] / 2 ; @ z2 = $pnc[3] - 1 ; breaksw
  default :
    stderr $argv[2] : bad half space. ; exit 1
endsw
#
sliceIT $fsd - $x1 $y1 $z1 $x2 $y2 $z2 $hsd
