#!/bin/csh
# usage : add.label.[L,C,R][U,D] font size R G B {TIFF label}
#
set run=($0 $argv)
set exe=`basename $0`
#
set tmp=/tmp/AAAa$$
#
if ($exe !~ add.label.[L,C,R][U,D]) then
  stderr $exe: unknown command. ; exit 1
else
  if ($#argv != 5 && $#argv < 7) then
    stderr "usage : $exe font size R G B {TIFF label}" ; exit 1
  endif
endif
#
if ($#argv == 5) then
  awk -v run="${run}" '{ print run,$0 }' | csh
else
  set wl=(`tiffwl $argv[6]`) ; if ($status) exit 1
#
  switch(`echo $exe | cut -c11`)
    case L :
      set x=($argv[2] 0.5 mul) ; breaksw
    case C :
      set x=(dup stringwidth pop $wl[1] sub 2 div neg) ; breaksw
    case R :
      set x=(dup stringwidth pop $wl[1] sub $argv[2] 0.5 mul add neg) ; breaksw
  endsw
  switch(`echo $exe | cut -c12`)
    case U :
      set y=($wl[2] $argv[2] 1.375 mul sub) ; breaksw
    case D :
      set y=($argv[2] 0.625 mul) ; breaksw
  endsw
  echo \("${argv[7-]}"\) \
       /$argv[1] findfont $argv[2] scalefont setfont \
       newpath $x $y moveto show showpage | \
  gs -r72 -g${wl[1]}x$wl[2] -sDEVICE=pbmraw -sOutputFile=- -q - | pnm2tiff $tmp
  tiffmask $tmp 3 $argv[6] -$argv[3-5] $argv[6]
  rm $tmp
endif
