
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "slice.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,BPS,x,y,z,R,*C0,r;
	double	xO,yO,zO,*C1,*C2,d,rx,ry,rz,base,step,c,M,V;
	char	**names;
	Cell	**cell;

	if (argc!=3 && argc!=5 && argc!=6 && argc!=8)
	    Error("usage : ac_rp directory nameFile {xO yO zO} {base step}");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,&BPS,NULL);

	cell=AllocateSliceMemory(Nx,Ny);

	if (argc==3 || argc==5) {
	    xO=(double)(Nx-1)/2.0;
	    yO=(double)(Ny-1)/2.0;
	    zO=(double)(Nz-1)/2.0;
	}
	else {
	    xO=atof(argv[3]);
	    yO=atof(argv[4]);
	    zO=atof(argv[5]);
	}

	if ((d=fabs(xO))>(rx=fabs((double)(Nx-1)-xO))) rx=d;
	if ((d=fabs(yO))>(ry=fabs((double)(Ny-1)-yO))) ry=d;
	if ((d=fabs(zO))>(rz=fabs((double)(Nz-1)-zO))) rz=d;
	R=(int)floor(sqrt(rx*rx+ry*ry+rz*rz))+1;

	if ((C0=(int    *)malloc(R*sizeof(*C0)))==NULL ||
	    (C1=(double *)malloc(R*sizeof(*C1)))==NULL ||
	    (C2=(double *)malloc(R*sizeof(*C2)))==NULL)
	    Error("counter memory allocation error.");

	for (r=0; r<R; r++) C2[r]=C1[r]=(double)(C0[r]=0);

	if (argc==3 || argc==6) {
	    base=0.0;
	    step=1.0/(double)((1<<BPS)-1);
	}
	else {
	    base=atof(argv[argc-2]);
	    step=atof(argv[argc-1]);
	}

	for (z=0; z<Nz; z++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&cell);

	    d=(double)z-zO; rz=d*d;
	    for (y=0; y<Ny; y++) {
		d=(double)y-yO; ry=rz+d*d;
		for (x=0; x<Nx; x++) {
		    d=(double)x-xO; r=(int)floor(sqrt(ry+d*d));
		    ++C0[r];
		    c=base+step*(double)cell[y][x]; C1[r]+=c; C2[r]+=(c*c);
		}
	    }
	}
	for (r=0; r<R; r++) {
	    M=(C0[r]==0)?0.0:C1[r]/(double)C0[r];
	    printf("%d\t%d\t%lf\t%lf\n",
		   r,C0[r],M,
		   (C0[r]<=1 || (V=C2[r]/(double)C0[r]-M*M)<=0.0)?0.0:sqrt(V));
	}
	return 0;
}
