
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,xO,yO,zO,Ix,Iy,Iz,x,y,z;
	char	**names,**descs;
	Cell	**cell;
	double	a,b,c;

	if (argc!=7 && argc!=10)
	    Error("usage : ac_sasc orgDir nameFile {xO yO zO} Ix Iy Iz newDir");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,&descs);

	cell=AllocateSliceMemory(Nx,Ny);

	if (argc==7) {
	    xO=Nx/2; yO=Ny/2; zO=Nz/2;
	}
	else {
	    xO=atoi(argv[3]); yO=atoi(argv[4]); zO=atoi(argv[5]);
	}

	if ((Ix=atoi(argv[argc-4]))<=abs(xO) || Ix<=abs(Nx-1-xO) ||
	    (Iy=atoi(argv[argc-3]))<=abs(yO) || Iy<=abs(Ny-1-yO) ||
	    (Iz=atoi(argv[argc-2]))<=abs(zO) || Iz<=abs(Nz-1-zO))
	    Error("bad image size.");

	a=1.0/((double)Ix*(double)Iy*(double)Iz);
	for (z=0; z<Nz; z++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&cell);

	    b=(double)(Iz-abs(z-zO))*a;
	    for (y=0; y<Ny; y++) {
		c=(double)(Iy-abs(y-yO))*b;
		for (x=0; x<Nx; x++)
		    cell[y][x]=(Cell)((double)(Ix-abs(x-xO))*c*
				      (double)cell[y][x]+0.5);
	    }
	    StoreImageFile(argv[argc-1],names+z,&cell,0,0,0,Nx-1,Ny-1,0,
			   GetImageBPS(&cell,0,0,0,Nx-1,Ny-1,0),descs+z,NULL);
	}
	return 0;
}
