
#include <math.h>
#include "bev.h"

#define NH	bev.Nh
#define NV	bev.Nv
#define ND	bev.Nd
#define HX	bev.hx
#define HY	bev.hy
#define HZ	bev.hz
#define VX	bev.vx
#define VY	bev.vy
#define VZ	bev.vz
#define DX	bev.dx
#define DY	bev.dy
#define DZ	bev.dz
#define H0	bev.h0
#define V0	bev.v0
#define D0	bev.d0

#define MINMAX(exp)	hvd=exp; if (hvd<min) min=hvd; if (hvd>max) max=hvd

BEV	SetUpBEV(xMin,yMin,zMin,xMax,yMax,zMax,lon,lat)
double	xMin,yMin,zMin,xMax,yMax,zMax,lon,lat;
{
	BEV	bev;
	double	min,max,hvd,clon=cos(lon),clat=cos(lat),
			    slon=sin(lon),slat=sin(lat);

	HX=slon      ; HY=(-clon     ); HZ=   0.0 ;
	VX=clon*slat ; VY=  slon*slat ; VZ=(-clat);
	DX=clon*clat ; DY=  slon*clat ; DZ=  slat ;

	min=max=xMin*HX+yMin*HY+zMin*HZ;
	MINMAX(xMax*HX+yMin*HY+zMin*HZ);
	MINMAX(xMin*HX+yMax*HY+zMin*HZ);
	MINMAX(xMax*HX+yMax*HY+zMin*HZ);
	MINMAX(xMin*HX+yMin*HY+zMax*HZ);
	MINMAX(xMax*HX+yMin*HY+zMax*HZ);
	MINMAX(xMin*HX+yMax*HY+zMax*HZ);
	MINMAX(xMax*HX+yMax*HY+zMax*HZ); H0=min; NH=(int)ceil(max-min)+2;

	min=max=xMin*VX+yMin*VY+zMin*VZ;
	MINMAX(xMax*VX+yMin*VY+zMin*VZ);
	MINMAX(xMin*VX+yMax*VY+zMin*VZ);
	MINMAX(xMax*VX+yMax*VY+zMin*VZ);
	MINMAX(xMin*VX+yMin*VY+zMax*VZ);
	MINMAX(xMax*VX+yMin*VY+zMax*VZ);
	MINMAX(xMin*VX+yMax*VY+zMax*VZ);
	MINMAX(xMax*VX+yMax*VY+zMax*VZ); V0=min; NV=(int)ceil(max-min)+2;

	min=max=xMin*DX+yMin*DY+zMin*DZ;
	MINMAX(xMax*DX+yMin*DY+zMin*DZ);
	MINMAX(xMin*DX+yMax*DY+zMin*DZ);
	MINMAX(xMax*DX+yMax*DY+zMin*DZ);
	MINMAX(xMin*DX+yMin*DY+zMax*DZ);
	MINMAX(xMax*DX+yMin*DY+zMax*DZ);
	MINMAX(xMin*DX+yMax*DY+zMax*DZ);
	MINMAX(xMax*DX+yMax*DY+zMax*DZ); D0=min; ND=(int)ceil(max-min)+2;

	return bev;
}

void	LightDirection(lon,lat,lx,ly,lz)
double	lon,lat,*lx,*ly,*lz;
{
	*lx=cos(lon)*cos(lat);
	*ly=sin(lon)*cos(lat);
	*lz=         sin(lat);
}
