
#include <stdio.h>
#include <stdlib.h>
#include "cmimage.h"

static int	*lut;
static word	*cmR,*cmG,*cmB;

static void	QSort(lower,upper)
int		lower,upper;
{
	int	tmp,r,g,b,i,j,dif;

	if (lower>=upper) return;

	tmp=lut[(lower+upper)/2]; r=(int)cmR[tmp];
				  g=(int)cmG[tmp];
				  b=(int)cmB[tmp]; i=lower; j=upper;
	do {
	    for (;; ++i) { tmp=lut[i];
		if ((dif=(int)cmB[tmp]-b)<0) continue; if (dif>0) break;
		if ((dif=(int)cmG[tmp]-g)<0) continue; if (dif>0) break;
		if ((dif=(int)cmR[tmp]-r)<0) continue;            break;
	    }
	    for (;; --j) { tmp=lut[j];
		if ((dif=(int)cmB[tmp]-b)>0) continue; if (dif<0) break;
		if ((dif=(int)cmG[tmp]-g)>0) continue; if (dif<0) break;
		if ((dif=(int)cmR[tmp]-r)>0) continue;            break;
	    }
	    if (i<=j) {
		if (i<j) { tmp=lut[i]; lut[i]=lut[j]; lut[j]=tmp; }
		++i; --j;
	    }
	} while (i<=j);

	QSort(lower,j);
	QSort(i,upper);
}

CM	*CM2CM(image,cm)
Image	*image;
CM	*cm;
{
	int	pixel,x,y,pixels,*ptr,
		*pxl=(int *)calloc(cm->pixels,sizeof(*pxl));
	CM	*tmp;
	word	r,g,b;

	if (pxl==NULL ||
	   (lut=(int *)calloc(cm->pixels,sizeof(*lut)))==NULL) return(NULL);

	for (ptr=lut, pixel=0; pixel<cm->pixels; pixel++, ptr++) *ptr=(-1);

	for (x=0; x<image->xSize; x++)
	for (y=0; y<image->ySize; y++) {
	    pixel=GETPIXEL(image,x,y); lut[pixel]=0;
	}
	pixels=0;
	for (ptr=lut, pixel=0; pixel<cm->pixels; pixel++, ptr++)
	    if (*ptr==0) { *ptr=pixels; ++pixels; }

	if (pixels<cm->pixels) {
	    if ((tmp=AllocCM(pixels))==NULL) return(NULL);

	    for (ptr=lut, pixel=0; pixel<cm->pixels; pixel++, ptr++)
		if (*ptr>=0) {
		    tmp->r[*ptr]=cm->r[pixel];
		    tmp->g[*ptr]=cm->g[pixel];
		    tmp->b[*ptr]=cm->b[pixel];
		}
	    FreeCM(cm); cm=tmp;
	    for (x=0; x<image->xSize; x++)
	    for (y=0; y<image->ySize; y++) {
		pixel=lut[GETPIXEL(image,x,y)]; PUTPIXEL(image,x,y,pixel);
	    }
	}

	for (ptr=lut, pixel=0; pixel<cm->pixels; pixel++, ptr++) *ptr=pixel;
	cmR=cm->r;
	cmG=cm->g;
	cmB=cm->b; QSort(0,cm->pixels-1);

	ptr=lut; r=cmR[*ptr];
		 g=cmG[*ptr];
		 b=cmB[*ptr]; pxl[*ptr]=pixels=0;
	for (++ptr, pixel=1; pixel<cm->pixels; pixel++, ptr++) {
	    if (cmR[*ptr]!=r ||
		cmG[*ptr]!=g ||
		cmB[*ptr]!=b) { r=cmR[*ptr];
				g=cmG[*ptr];
				b=cmB[*ptr]; ++pixels; }
	    pxl[*ptr]=pixels;
	}

	if (++pixels<cm->pixels) {
	    if ((tmp=AllocCM(pixels))==NULL) return(NULL);

	    for (ptr=pxl, pixel=0; pixel<cm->pixels; pixel++, ptr++) {
		tmp->r[*ptr]=cm->r[pixel];
		tmp->g[*ptr]=cm->g[pixel];
		tmp->b[*ptr]=cm->b[pixel];
	    }
	    FreeCM(cm); cm=tmp;
	    for (x=0; x<image->xSize; x++)
	    for (y=0; y<image->ySize; y++) {
		pixel=pxl[GETPIXEL(image,x,y)]; PUTPIXEL(image,x,y,pixel);
	    }
	}

	free(lut); free(pxl); return(cm);
}
