
#include <stdio.h>
#include <stdlib.h>
#include "tiffio.h"
#include "cmimage.h"
#include "readtiff.h"
#include "writetiff.h"

extern void	CopyTAGControl(),CopyTAG();

#define STRLEN	256

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	TIFF	*org,*new;
	Image	*image;
	CM	*cm;
	int	code,pixel,x,y;
	char	str[STRLEN];

	if (argc!=3) Error("usage : cm2rgb CMTIFF RGBTIFF");

	if ((org=TIFFOpen(argv[1],"r"))==NULL) Error("TIFF file not found.");

	if ((code=ReadTIFF(org,&image,&cm))>0) {
	    sprintf(str,"TIFF %s",ReadTIFFError(code)); Error(str);
	}
	if (cm==NULL) Error("RGB image is not acceptable.");

	for (pixel=0; pixel<cm->pixels; pixel++) {
	    cm->r[pixel]>>=8;
	    cm->g[pixel]>>=8;
	    cm->b[pixel]>>=8;
	}

#ifndef	RGB
	for (pixel=0; pixel<cm->pixels; pixel++)
	    if (cm->r[pixel]!=cm->g[pixel] ||
		cm->r[pixel]!=cm->b[pixel]) break;

	if (pixel==cm->pixels) {
	    for (x=0; x<image->xSize; x++) for (y=0; y<image->ySize; y++) {
		pixel=GETPIXEL(image,x,y); image->r[x][y]=(byte)cm->r[pixel];
					   image->g[x][y]=
					   image->b[x][y]=0;
	    }
	    FreeCM(cm);
	    if ((cm=AllocCM(256))==NULL) Error("colormap allocation error.");

	    for (pixel=0; pixel<256; pixel++)
		cm->r[pixel]=
		cm->g[pixel]=
		cm->b[pixel]=(word)((0xffff*pixel)/255);
	}
	else
#endif
	{
	    for (x=0; x<image->xSize; x++) for (y=0; y<image->ySize; y++) {
		pixel=GETPIXEL(image,x,y); image->r[x][y]=(byte)cm->r[pixel];
					   image->g[x][y]=(byte)cm->g[pixel];
					   image->b[x][y]=(byte)cm->b[pixel];
	    }
	    FreeCM(cm); cm=NULL;
	}

	if ((new=TIFFOpen(argv[2],"w"))==NULL) Error("TIFF file not created.");

	CopyTAGControl(TIFFTAG_COLORMAP,0); CopyTAG(org,new); TIFFClose(org);

	if ((code=WriteTIFF(new,image,cm))>0) {
	    sprintf(str,"TIFF %s",WriteTIFFError(code)); Error(str);
	}

	TIFFClose(new); return(0);
}
