
#include <stdio.h>
#include <stdlib.h>
#include "cmimage.h"

#define R	(image->r)
#define G	(image->g)
#define B	(image->b)
#define XSIZE	(image->xSize)
#define YSIZE	(image->ySize)

Image	*AllocImage(xSize,ySize)
int	xSize,ySize;
{
	Image	*image=(Image *)malloc(sizeof(*image));
	int	x;

	if (image==NULL) return(NULL);

	if ((R=(byte **)calloc(xSize,sizeof(*R)))==NULL ||
	    (G=(byte **)calloc(xSize,sizeof(*G)))==NULL ||
	    (B=(byte **)calloc(xSize,sizeof(*B)))==NULL) return(NULL);

	for (x=0; x<xSize; x++)
	    if ((R[x]=(byte *)calloc(ySize,sizeof(**R)))==NULL ||
	        (G[x]=(byte *)calloc(ySize,sizeof(**G)))==NULL ||
	        (B[x]=(byte *)calloc(ySize,sizeof(**B)))==NULL) return(NULL);

	XSIZE=xSize; YSIZE=ySize; return(image);
}

void	FreeImage(image)
Image	*image;
{
	int	x;

	for (x=XSIZE-1; x>=0; x--) {
	    free(B[x]); free(G[x]); free(R[x]);
	}
	free(B); free(G); free(R); free(image);
}

#define PIXELS	(cm->pixels)
#define CMR	(cm->r)
#define CMG	(cm->g)
#define CMB	(cm->b)

CM	*AllocCM(pixels)
int	pixels;
{
	CM	*cm=(CM *)malloc(sizeof(*cm));

	if (cm==NULL) return(NULL);

	if ((CMR=(word *)calloc(pixels,sizeof(*CMR)))==NULL ||
	    (CMG=(word *)calloc(pixels,sizeof(*CMG)))==NULL ||
	    (CMB=(word *)calloc(pixels,sizeof(*CMB)))==NULL) return(NULL);

	PIXELS=pixels; return(cm);
}

void	FreeCM(cm)
CM	*cm;
{
	free(CMB); free(CMG); free(CMR); free(cm);
}
