
typedef unsigned char	byte;
typedef unsigned short	word;

typedef struct {
		int	xSize,ySize;
		byte	**r,**g,**b;
	} Image;

typedef struct {
		int	pixels;
		word	*r,*g,*b;
	} CM;

extern Image	*AllocImage(/* int xSize, int ySize */);
extern void	FreeImage(/* Image *image */);

extern CM	*AllocCM(/* int pixels */),
		*RGB2CM(/* Image *image */),
		*CM2CM(/* Image *image, CM *cm */),
		*ReduceCM(/* Image *image, CM *cm, int pixels */);
extern void	FreeCM(/* CM *cm */);

#define PUTPIXEL(image,x,y,pixel)	{\
	image->r[x][y]=(byte)( pixel     &0xff);\
	image->g[x][y]=(byte)((pixel>> 8)&0xff);\
	image->b[x][y]=(byte)((pixel>>16)&0xff);\
}
#define GETPIXEL(image,x,y)	((int)image->r[x][y]     |\
				((int)image->g[x][y]<< 8)|\
				((int)image->b[x][y]<<16))
