
#include <memory.h>
#include "lzw.h"

#ifdef	FAST
#define TBLSIZE	9001
#define SHIFT	5
#else
#define TBLSIZE	5003
#define SHIFT	4
#endif

static int	curBits=0;
static long	curData=0L;

static void	Put(code,size,put)
int		code,size;
void		(*put)();
{
	curData|=((long)code<<curBits);

	for (curBits+=size; curBits>=8; curBits-=8) {
	    (*put)((int)(curData&0xff)); curData>>=8;
	}
}

#define Clear(table,size)	(void)memset(table,0xff,sizeof(*(table))*(size))
#define EMPTY			(~0L)

#define MAXCODE	(1<<MAXBITS)
#define MINCODE	(clrCode+2)
#define EODCODE	(clrCode+1)

void	Compress(codeSize,getByte,putByte,appendEODCode)
int	codeSize,(*getByte)(),appendEODCode;
void	(*putByte)();
{
	int	numBits,limCode,entCode,oldCode,newCode,idx,code[TBLSIZE],stp,
		minBits=(codeSize+1<MINBITS)?MINBITS:codeSize+1,
		clrCode=1<<(minBits-1);
	long	keyTbl[TBLSIZE],key;

	numBits=minBits; limCode=(1<<numBits)-1; entCode=MINCODE;
	Clear(keyTbl,TBLSIZE);

	Put(clrCode,numBits,putByte);

	if ((oldCode=(*getByte)())>=0) {
	    while ((newCode=(*getByte)())>=0) {
		key=(long)oldCode|((long)newCode<<MAXBITS);
		idx=(newCode<<SHIFT)^oldCode;

		if (keyTbl[idx]==key) {
		    oldCode=code[idx]; continue;
		}
		else
		    if (keyTbl[idx]==EMPTY) goto NoMatch;

		stp=(idx==0)?1:TBLSIZE-idx;
TryAgain:
		if ((idx-=stp)<0) idx+=TBLSIZE;

		if (keyTbl[idx]==key) {
		    oldCode=code[idx]; continue;
		}
		else
		    if (keyTbl[idx]!=EMPTY) goto TryAgain;
NoMatch:
		Put(oldCode,numBits,putByte);

		if (entCode<MAXCODE) {
		    if (entCode>limCode) {
			++numBits; limCode=(1<<numBits)-1;
		    }
		    keyTbl[idx]=key; code[idx]=entCode++;
		}
		else {
		    Put(clrCode,numBits,putByte);

		    numBits=minBits; limCode=(1<<numBits)-1; entCode=MINCODE;
		    Clear(keyTbl,TBLSIZE);
		}
		oldCode=newCode;
	    }
	    Put(oldCode,numBits,putByte);
	}

	if (appendEODCode) Put(EODCODE,numBits,putByte);

	while (curBits>0) {
	    (*putByte)((int)(curData&0xff)); curData>>=8; curBits-=8;
	}
	curBits=0;
}
