
#include <stdio.h>
#include <stdlib.h>
#include "tiffio.h"

static char	*slmna="TIFF scan line memory not allocated.",
		*nild ="TIFF no image length description.",
		*slwe ="TIFF scan line write error.";

char	*CopyScanline(org,new)
TIFF	*org,*new;
{
	uint8	*col;
	uint32	len,row;
	uint16	pc,spp,spl;

	if ((col=(uint8 *)malloc(TIFFScanlineSize(org)))==NULL) return(slmna);

	if (!TIFFGetField(org,TIFFTAG_IMAGELENGTH,&len)) return(nild);

	if (!TIFFGetField(org,TIFFTAG_PLANARCONFIG,&pc))
	    TIFFGetFieldDefaulted(org,TIFFTAG_PLANARCONFIG,&pc);

	if (pc==PLANARCONFIG_CONTIG)
	    spp=1;
	else
	    if (!TIFFGetField(org,TIFFTAG_SAMPLESPERPIXEL,&spp))
		TIFFGetFieldDefaulted(org,TIFFTAG_SAMPLESPERPIXEL,&spp);

	for (spl=0; spl<spp; spl++)
	for (row=0; row<len; row++) {
	    if (TIFFReadScanline( org,col,row,spl)<0) goto Return;
	    if (TIFFWriteScanline(new,col,row,spl)<0) return(slwe);
	}
Return:;
	free(col); return(NULL);
}
