
#include "tiffio.h"
#include "copytag.h"

void	CopyTAGControl(tag,flg)
ttag_t	tag;
int	flg;
{
	int	idx;

	for (idx=0; idx<TAGS; idx++) if (tag==tags[idx].tag) break;

	tags[idx].flg=flg;
}

static int	Check(tag)
ttag_t		tag;
{
	int	idx;

	for (idx=0; idx<TAGS; idx++) if (tag==tags[idx].tag) break;

	return(tags[idx].flg);
}

#define Copy1(tag,type1) \
{ \
	type1	var1; \
	if (Check(tag)) if (TIFFGetField(org,tag,&var1)) \
			    TIFFSetField(new,tag, var1); \
}
#define Copy2(tag,type1,type2) \
{ \
	type1	var1; \
	type2	var2; \
	if (Check(tag)) if (TIFFGetField(org,tag,&var1,&var2)) \
			    TIFFSetField(new,tag, var1, var2); \
}
#define Copy3(tag,type1,type2,type3) \
{ \
	type1	var1; \
	type2	var2; \
	type3	var3; \
	if (Check(tag)) if (TIFFGetField(org,tag,&var1,&var2,&var3)) \
			    TIFFSetField(new,tag, var1, var2, var3); \
}

void	CopyTAG(org,new)
TIFF	*org,*new;
{
	Copy1(TIFFTAG_ARTIST,			char*);
	Copy1(TIFFTAG_BADFAXLINES,		uint32);
	Copy1(TIFFTAG_BITSPERSAMPLE,		uint16);
/*
	TIFFTAG_CELLLENGTH
	TIFFTAG_CELLWIDTH
*/
	Copy1(TIFFTAG_CLEANFAXDATA,		uint16);
	Copy3(TIFFTAG_COLORMAP,			uint16*,uint16*,uint16*);
/*
	TIFFTAG_COLORRESPONSEUNIT
*/
	Copy1(TIFFTAG_COMPRESSION,		uint16);
	Copy1(TIFFTAG_CONSECUTIVEBADFAXLINES,	uint32);
/*
	TIFFTAG_COPYRIGHT
	TIFFTAG_DATATYPE
*/
	Copy1(TIFFTAG_DATETIME,			char*);
	Copy1(TIFFTAG_DOCUMENTNAME,		char*);
	Copy2(TIFFTAG_DOTRANGE,			uint16,uint16);
	Copy2(TIFFTAG_EXTRASAMPLES,		uint16,uint16*);
/*
	Copy1(TIFFTAG_FAXFILLFUNC,		TIFFFaxFillFunc);
*/
	Copy1(TIFFTAG_FAXMODE,			int);
/*
	TIFFTAG_FAXRECVPARAMS
	TIFFTAG_FAXRECVTIME
	TIFFTAG_FAXSUBADDRESS
*/
	Copy1(TIFFTAG_FILLORDER,		uint16);
/*
	TIFFTAG_FREEBYTECOUNTS
	TIFFTAG_FREEOFFSETS
	TIFFTAG_GRAYRESPONSECURVE
	TIFFTAG_GRAYRESPONSEUNIT
*/
	Copy1(TIFFTAG_GROUP3OPTIONS,		uint32);
	Copy1(TIFFTAG_GROUP4OPTIONS,		uint32);
	Copy2(TIFFTAG_HALFTONEHINTS,		uint16,uint16);
	Copy1(TIFFTAG_HOSTCOMPUTER,		char*);
	Copy1(TIFFTAG_IMAGEDEPTH,		uint32);
	Copy1(TIFFTAG_IMAGEDESCRIPTION,		char*);
	Copy1(TIFFTAG_IMAGELENGTH,		uint32);
	Copy1(TIFFTAG_IMAGEWIDTH,		uint32);
	Copy1(TIFFTAG_INKNAMES,			char*);
	Copy1(TIFFTAG_INKSET,			uint16);
/*
	TIFFTAG_JBIGOPTIONS
	TIFFTAG_JPEGACTABLES
*/
	Copy1(TIFFTAG_JPEGCOLORMODE,		int);
/*
	TIFFTAG_JPEGDCTABLES
	TIFFTAG_JPEGIFBYTECOUNT
	TIFFTAG_JPEGIFOFFSET
	TIFFTAG_JPEGLOSSLESSPREDICTORS
	TIFFTAG_JPEGPOINTTRANSFORM
	TIFFTAG_JPEGPROC
	TIFFTAG_JPEGQTABLES
*/
	Copy1(TIFFTAG_JPEGQUALITY,		int);
/*
	TIFFTAG_JPEGRESTARTINTERVAL
*/
	Copy2(TIFFTAG_JPEGTABLES,		uint32*,void*);
	Copy1(TIFFTAG_JPEGTABLESMODE,		int);
	Copy1(TIFFTAG_MAKE,			char*);
	Copy1(TIFFTAG_MATTEING,			uint16);
	Copy1(TIFFTAG_MAXSAMPLEVALUE,		uint16);
	Copy1(TIFFTAG_MINSAMPLEVALUE,		uint16);
	Copy1(TIFFTAG_MODEL,			char*);
	Copy1(TIFFTAG_ORIENTATION,		uint16);
/*
	TIFFTAG_OSUBFILETYPE
*/
	Copy1(TIFFTAG_PAGENAME,			char*);
	Copy2(TIFFTAG_PAGENUMBER,		uint16,uint16);
	Copy1(TIFFTAG_PHOTOMETRIC,		uint16);
/*
	TIFFTAG_PIXARLOGDATAFMT
*/
	Copy1(TIFFTAG_PLANARCONFIG,		uint16);
	Copy1(TIFFTAG_PREDICTOR,		uint16);
	Copy1(TIFFTAG_PRIMARYCHROMATICITIES,	float);
	Copy1(TIFFTAG_REFERENCEBLACKWHITE,	float*);
	Copy1(TIFFTAG_RESOLUTIONUNIT,		uint16);
	Copy1(TIFFTAG_ROWSPERSTRIP,		uint32);
	Copy1(TIFFTAG_SAMPLEFORMAT,		uint16);
	Copy1(TIFFTAG_SAMPLESPERPIXEL,		uint16);
	Copy1(TIFFTAG_SMAXSAMPLEVALUE,		double);
	Copy1(TIFFTAG_SMINSAMPLEVALUE,		double);
	Copy1(TIFFTAG_SOFTWARE,			char*);
/*
	TIFFTAG_STRIPBYTECOUNTS
	TIFFTAG_STRIPOFFSETS
*/
	Copy1(TIFFTAG_SUBFILETYPE,		uint32);
	Copy2(TIFFTAG_SUBIFD,			uint16,uint32*);
	Copy1(TIFFTAG_TARGETPRINTER,		char*);
	Copy1(TIFFTAG_THRESHHOLDING,		uint16);
	Copy1(TIFFTAG_TILEDEPTH,		uint32);
	Copy1(TIFFTAG_TILELENGTH,		uint32);
	Copy1(TIFFTAG_TILEWIDTH,		uint32);
/*
	Copy1(TIFFTAG_TRANSFERFUNCTION,		uint16*);
*/
	Copy3(TIFFTAG_TRANSFERFUNCTION,		uint16*,uint16*,uint16*);
	Copy1(TIFFTAG_WHITEPOINT,		float);
	Copy1(TIFFTAG_XPOSITION,		float);
	Copy1(TIFFTAG_XRESOLUTION,		float);
	Copy1(TIFFTAG_YCBCRCOEFFICIENTS,	float*);
	Copy1(TIFFTAG_YCBCRPOSITIONING,		uint16);
	Copy2(TIFFTAG_YCBCRSUBSAMPLING,		uint16,uint16);
	Copy1(TIFFTAG_YPOSITION,		float);
	Copy1(TIFFTAG_YRESOLUTION,		float);
/*
	TIFFTAG_FRAMECOUNT
	TIFFTAG_PIXAR_IMAGEFULLLENGTH
	TIFFTAG_PIXAR_IMAGEFULLWIDTH
	TIFFTAG_REFPTS
	TIFFTAG_REGIONAFFINE
	TIFFTAG_REGIONTACKPOINT
	TIFFTAG_REGIONWARPCORNERS
	TIFFTAG_TILEBYTECOUNTS
	TIFFTAG_TILEOFFSETS
*/
}
