
#include <stdio.h>
#include <stdlib.h>
#include "cmimage.h"

#ifndef BIT
#define BIT	4
#endif

#ifndef	HASH
#define HASH	0
#endif

#define SIZE	(1<<BIT)

#if	HASH==0
#define MASK(rgb)	((rgb)>>(8-BIT))
#else
#define MASK(rgb)	((rgb)&(SIZE-1))
#endif

typedef union {
		int	i;
		struct {
			byte	r,g,b,noUse;
		} s;
	} RGB;

#define List	struct LIST
	List {
		RGB	rgb;
		int	pixel;
		List	*next;
	};

static List	*top[SIZE][SIZE][SIZE];

#define B2W(rgb)	(((word)(rgb)<<8)|(word)(rgb))

CM	*RGB2CM(image)
Image	*image;
{
	int	r,g,b,pixel,x,y;
	List	**last,*list,*next;
	RGB	rgb;
	CM	*cm;

	for (r=0; r<SIZE; r++)
	for (g=0; g<SIZE; g++)
	for (b=0; b<SIZE; b++) top[r][g][b]=NULL; rgb.i=0;

	pixel=0;
	for (x=0; x<image->xSize; x++)
	for (y=0; y<image->ySize; y++) {
	    last=(&(top[MASK(rgb.s.r=image->r[x][y])]
		       [MASK(rgb.s.g=image->g[x][y])]
		       [MASK(rgb.s.b=image->b[x][y])]));
	    for (list=(*last); list!=NULL; list=(*last))
		if (list->rgb.i==rgb.i) break; else last=(&(list->next));

	    if (list==NULL) {
		if ((*last=(List *)malloc(sizeof(**last)))==NULL) return(NULL);

		(*last)->rgb.i=rgb.i; (*last)->pixel=pixel; (*last)->next=NULL;
		PUTPIXEL(image,x,y,pixel); ++pixel;
	    }
	    else
		PUTPIXEL(image,x,y,list->pixel);
	}

	if ((cm=AllocCM(pixel))==NULL) return(NULL);

	for (r=0; r<SIZE; r++)
	for (g=0; g<SIZE; g++)
	for (b=0; b<SIZE; b++)
	    for (list=top[r][g][b]; list!=NULL; list=next) {
		cm->r[list->pixel]=B2W(list->rgb.s.r);
		cm->g[list->pixel]=B2W(list->rgb.s.g);
		cm->b[list->pixel]=B2W(list->rgb.s.b);
		next=list->next; free(list);
	    }

	return(cm);
}
