
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

extern Cell	SpatialFilter(/* int x, int y, int z, Cell ***cell */);

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	*str,*ptr,**names;
	int	Nz,Nx,Ny,z,y,x;
	Cell	**slice,***cell;

	if (argc!=4) {
	    for (str=ptr=argv[0]; *ptr!='\0'; ptr++) if (*ptr=='/') str=ptr+1;

	    fprintf(stderr,"usage : %s orgDir nameFile newDir\n",str); exit(1);
	}

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,NULL);

	slice=AllocateSliceMemory(Nx,Ny);

	if ((cell=(Cell ***)malloc((Nz+SF_HW*2)*sizeof(*cell)))==NULL)
	    Error("cell memory allocation error.");

	for (z=0; z<1+SF_HW*2; z++) {
	    cell[z]=AllocateSliceMemory(Nx+SF_HW*2,Ny+SF_HW*2);

	    for (y=0; y<Ny+SF_HW*2; y++) cell[z][y]+=SF_HW;

	    cell[z]+=SF_HW;
	}
	for (z=1+SF_HW*2; z<Nz+SF_HW*2; z++) cell[z]=cell[z%(1+SF_HW*2)];

	cell+=SF_HW;

	for (z=0; z<SF_HW && z<Nz; z++)
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,cell+z);

	for (z=0; z<Nz; z++) {
	    if (z+SF_HW<Nz)
		ReadImageFile(argv[1],names+z+SF_HW,Nx,Ny,1,cell+z+SF_HW);
	    else
		for (y=0; y<Ny; y++)
		for (x=0; x<Nx; x++) cell[z+SF_HW][y][x]=0;

	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) slice[y][x]=SpatialFilter(x,y,z,cell);

	    StoreImageFile(argv[3],names+z,&slice,0,0,0,Nx-1,Ny-1,0,
			   GetImageBPS(&slice,0,0,0,Nx-1,Ny-1,0),NULL,NULL);
	}
	return 0;
}
