
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "slice.h"

#ifndef	Flag
#define Flag	char
#endif

#ifndef	BPS
#define BPS	8
#endif

static int	ScanDistance(arg,N)
char		*arg;
int		N;
{
	return (*arg=='-')?atoi(++arg):(int)(atof(arg)*(double)N+0.5);
}

#define STR_LEN		512
#define MA(noe,ptr)	malloc((noe)*sizeof(*(ptr)))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,bps,lo,up,Lx,Ly,Lz,
		Nx1,Nx1Lx,Lx2,Lx21,Ny1,Ny1Ly,Ly2,Ly21,Lz1,***C,
		dz,dy,dx,z,y,x,z0,dz1,y0,dy1,dy2,x0,dx1,dx2,***Cz,**Cy,*Cx;
	char	**names,desc[STR_LEN],*name[1],str[STR_LEN],format[STR_LEN],
		*cmae="counter memory allocation error.",
		*fmae="flag memory allocation error.";
	Flag	***B,***Bz,**By,*Bx,***Az,**Ay,*Ax;
	Cell	**slice,**Sy,*Sx;
	double	p,rz,ry;

	if (argc!=7 && argc!=9)
Error("usage : slice2CFC org name {lower upper} ratioX ratioY ratioZ new");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,&bps,NULL);

	if (argc==7) {
	    lo=1; up=(1<<bps)-1;
	}
	else
	    if ((lo=atoi(argv[3]))<0 ||
		(up=atoi(argv[4]))>=1<<bps || lo>up) Error("bad value range.");

	if ((Lx=ScanDistance(argv[argc-4],Nx))<0 || Lx>=Nx ||
	    (Ly=ScanDistance(argv[argc-3],Ny))<0 || Ly>=Ny ||
	    (Lz=ScanDistance(argv[argc-2],Nz))<0 || Lz>=Nz)
	    Error("bad correlation distance.");

	printf("%d\t%d\t%d\t",Lx,Ly,Lz);

	Nx1=Nx-1; Nx1Lx=Nx1-Lx; Lx2=Lx*2; Lx21=Lx2+1;
	Ny1=Ny-1; Ny1Ly=Ny1-Ly; Ly2=Ly*2; Ly21=Ly2+1; Lz1=Lz+1;

	if ((C=(int ***)MA(Lz1,C))==NULL) Error(cmae);

	C+=Lz;
	for (dz=(-Lz); dz<=0; dz++) {
	    if ((C[dz]=(int **)MA(Ly21,*C))==NULL) Error(cmae);

	    C[dz]+=Ly;
	    for (dy=(-Ly); dy<=Ly; dy++) {
		if ((C[dz][dy]=(int *)MA(Lx21,**C))==NULL) Error(cmae);

		C[dz][dy]+=Lx;
		for (dx=(-Lx); dx<=Lx; dx++) C[dz][dy][dx]=0;
	    }
	}

	if ((B=(Flag ***)MA(Nz,B))==NULL) Error(fmae);

	for (z=0; z<=Lz; z++) {
	    if ((B[z]=(Flag **)MA(Ny,*B))==NULL) Error(fmae);

	    for (y=0; y<Ny; y++)
		if ((B[z][y]=(Flag *)MA(Nx,**B))==NULL) Error(fmae);
	}
	for (z=Lz1; z<Nz; z++) B[z]=B[z%Lz1];

	slice=AllocateSliceMemory((Nx>=Lx21)?Nx:Lx21,(Ny>=Ly21)?Ny:Ly21);

	for (Bz=B, z=0; z<Nz; z++, Bz++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&slice);

	    for (By=(*Bz), Sy=slice, y=0; y<Ny; y++, Sy++, By++)
	    for (Bx=(*By), Sx=(*Sy), x=0; x<Nx; x++, Sx++, Bx++)
		*Bx=((int)*Sx>=lo && (int)*Sx<=up)?1:0;

	    z0=z+(dz1=(z<=Lz)?-z:-Lz);
	    for (By=(*Bz), y=0; y<Ny; y++, By++) {
		y0=y+(dy1=(y<=Ly)?-y:-Ly); dy2=(y>=Ny1Ly)?Ny1-y:Ly;
		for (Bx=(*By), x=0; x<Nx; x++, Bx++)
		    if (*Bx) {
			x0=x+(dx1=(x<=Lx)?-x:-Lx); dx2=(x>=Nx1Lx)?Nx1-x:Lx;

for (Az=  B  +z0, Cz=  C  +(dz=dz1); dz<=  0; dz++, Cz++, Az++)
for (Ay=(*Az)+y0, Cy=(*Cz)+(dy=dy1); dy<=dy2; dy++, Cy++, Ay++)
for (Ax=(*Ay)+x0, Cx=(*Cy)+(dx=dx1); dx<=dx2; dx++, Cx++, Ax++) *Cx+=(int)*Ax;

		    }
	    }
	}
	p=(double)***C/(double)(Nx*Ny*Nz);
	sprintf(desc,"%lf",p);
	puts(desc);

	name[0]=str;
	sprintf(*name,"%d",Lz*2);
	sprintf(format,"%%0%dd.tif",strlen(*name));

	for (Cz=C+(dz=(-Lz)); dz<=0; dz++, Cz++) {
	    rz=(double)((1<<BPS)-1)/((double)(Nz+dz)*p);
	    for (Sy=slice, Cy=(*Cz)+(dy=(-Ly)); dy<=Ly; dy++, Cy++, Sy++) {
		ry=rz/(double)(Ny-abs(dy));
		for (Sx=(*Sy), Cx=(*Cy)+(dx=(-Lx)); dx<=Lx; dx++, Cx++, Sx++)
		    *Sx=(Cell)((double)*Cx*ry/(double)(Nx-abs(dx))+0.5);
	    }
	    sprintf(*name,format,dz+Lz);
	    StoreImageFile(argv[argc-1],name,&slice,0,0,0,Lx2,Ly2,0,
			   GetImageBPS(&slice,0,0,0,Lx2,Ly2,0),NULL,desc);
	}
	for (Cz=C-dz; dz<=Lz; dz++, Cz--) {
	    rz=(double)((1<<BPS)-1)/((double)(Nz-dz)*p);
	    for (Sy=slice, Cy=(*Cz)+(dy=Ly); dy>=(-Ly); dy--, Cy--, Sy++) {
		ry=rz/(double)(Ny-abs(dy));
		for (Sx=(*Sy), Cx=(*Cy)+(dx=Lx); dx>=(-Lx); dx--, Cx--, Sx++)
		    *Sx=(Cell)((double)*Cx*ry/(double)(Nx-abs(dx))+0.5);
	    }
	    sprintf(*name,format,dz+Lz);
	    StoreImageFile(argv[argc-1],name,&slice,0,0,0,Lx2,Ly2,0,
			   GetImageBPS(&slice,0,0,0,Lx2,Ly2,0),NULL,desc);
	}
	return 0;
}
