
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "slice.h"

#define STR_LEN		512
#define MA(ptr,noe)	malloc(sizeof(*(ptr))*(noe))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,Sx,Sy,Sz,Nh,Nv,**count,v,h,z,y,x;
	char	**names,*name[1],str[STR_LEN],format[STR_LEN],
		*bss="bad segment size.",
		*amae="array memory allocation error.";
	Cell	**cell;
	double	**value;

	if (argc!=5 && argc!=7)
	    Error("usage : sliceBIC orgDir nameFile Sxyz|(Sx Sy Sz) newDir");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,NULL);

	if (argc==5) {
	    if ((Sx=Sy=Sz=atoi(argv[3]))<=0) Error(bss);
	}
	else
	    if ((Sx=atoi(argv[3]))<=0 ||
		(Sy=atoi(argv[4]))<=0 ||
		(Sz=atoi(argv[5]))<=0) Error(bss);

	cell=AllocateSliceMemory(Nx,Ny);

	Nh=(Nx+Sx-1)/Sx;
	Nv=(Ny+Sy-1)/Sy;

	if ((count=(int    **)MA(count,Nv))==NULL ||
	    (value=(double **)MA(value,Nv))==NULL) Error(amae);

	for (v=0; v<Nv; v++) {
	    if ((count[v]=(int    *)MA(*count,Nh))==NULL ||
		(value[v]=(double *)MA(*value,Nh))==NULL) Error(amae);

	    for (h=0; h<Nh; h++) {
		count[v][h]=0; value[v][h]=0.0;
	    }
	}

	name[0]=str;
	(void)sprintf(*name,"%d",(Nz-1)/Sz);
	(void)sprintf(format,"%%0%dd.tif",strlen(*name));

	for (z=0; z<Nz; z++) {
	    CheckImageFile(argv[1],1,names+z,&Nx,&Ny,NULL,NULL);
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&cell);

	    for (y=0; y<Ny; y++) { v=y/Sy;
	    for (x=0; x<Nx; x++) { h=x/Sx;
		++(count[v][h]); value[v][h]+=(double)cell[y][x];
	    }}

	    if (z==Nz-1 || z%Sz==Sz-1) {
		for (v=0; v<Nv; v++)
		for (h=0; h<Nh; h++) {
		    cell[v][h]=(Cell)(value[v][h]/(double)count[v][h]+0.5);

		    count[v][h]=0; value[v][h]=0.0;
		}
		(void)sprintf(*name,format,z/Sz);
		StoreImageFile(argv[argc-1],name,&cell,0,0,0,Nh-1,Nv-1,0,
			       GetImageBPS(&cell,0,0,0,Nh-1,Nv-1,0),NULL,NULL);
	    }
	}
	return 0;
}
