
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "slice.h"

static int	CheckCuboidBlock(cell,x1,y1,z1,x2,y2,z2,pv1,pv2)
Cell		***cell;
int		x1,y1,z1,x2,y2,z2,pv1,pv2;
{
	int	x,y,z;

	for (z=z1; z<=z2; z++)
	for (y=y1; y<=y2; y++)
	for (x=x1; x<=x2; x++)
	    if (cell[z][y][x]<pv1 || cell[z][y][x]>pv2) return 0; return 1;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,Bx,By,Bz,pvd,ooi,y,x,bps,z1,z2,z,y1,y2,x1,x2;
	char	**names,**descs;
	Cell	***cell,**slice;

	if (argc!=9)
	    Error("usage : sliceCBC orgDir nameFile Bx By Bz pvd ooi newDir");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,&descs);

	if ((Bx=atoi(argv[3]))<0 || Bx>=(Nx+1)/2 ||
	    (By=atoi(argv[4]))<0 || By>=(Ny+1)/2 ||
	    (Bz=atoi(argv[5]))<0 || Bz>=(Nz+1)/2) Error("bad block size.");

	if ((pvd=atoi(argv[6]))<0)
	    Error("bad in-block pixel value difference.");

	if ((ooi=atoi(argv[7]))<0 || ooi>=(1<<(8*sizeof(Cell))))
	    Error("bad pixel value for out of image area.");

	cell=AllocateImageMemory(Nx,Ny,Nz);
	slice=AllocateSliceMemory(Nx,Ny);

	ReadImageFile(argv[1],names,Nx,Ny,Nz,cell);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) slice[y][x]=(Cell)ooi;

	bps=GetImageBPS(&slice,0,0,0,0,0,0);

	for (z=0; z<Bz; z++)
	    StoreImageFile(argv[8],names+z,&slice,0,0,0,Nx-1,Ny-1,0,bps,
			   descs+z,NULL);

	for (z=Nz-Bz; z<Nz; z++)
	    StoreImageFile(argv[8],names+z,&slice,0,0,0,Nx-1,Ny-1,0,bps,
			   descs+z,NULL);

	for (z1=0, z2=Bz*2, z=Bz; z<Nz-Bz; z++, z1++, z2++) {
	    for (y1=0, y2=By*2, y=By; y<Ny-By; y++, y1++, y2++)
	    for (x1=0, x2=Bx*2, x=Bx; x<Nx-Bx; x++, x1++, x2++)
		slice[y][x]=(CheckCuboidBlock(cell,x1,y1,z1,x2,y2,z2,
						   (int)cell[z][y][x]-pvd,
						   (int)cell[z][y][x]+pvd))?
			    cell[z][y][x]:(Cell)ooi;

	    StoreImageFile(argv[8],names+z,&slice,0,0,0,Nx-1,Ny-1,0,
			   GetImageBPS(&slice,0,0,0,Nx-1,Ny-1,0),
			   descs+z,NULL);
	}
	return 0;
}
