
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

#define BITS		(8*sizeof(Cell))
#define MM(xyz,min,max)	if (xyz<min) min=xyz; if (xyz>max) max=xyz
#define RESTORE_CELL(z)	cell=depo[(z)/BITS]; mask=(Cell)(1<<((z)%BITS)); \
			for (y=y1; y<=y2; y++) \
			for (x=x1; x<=x2; x++) succ[y][x]=cell[y][x]&mask

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,lo,up,thick,
		z,y,x,x1,y1,z1,x2,y2,z2,t,x3,y3,z3,x4,y4,z4;
	char	**names,*nop="no occupied pixel.";
	Cell	***depo,**curr,**prev,**succ,**cell,mask;

	if (argc!=7)
	Error("usage : sliceED orgDir nameFile lower upper thickness newDir");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,NULL);

	if ((lo=atoi(argv[3]))<0 ||
	    (up=atoi(argv[4]))<lo) Error("bad pixel value range.");

	if ((thick=atoi(argv[5]))<0) Error("bad thickness.");

	depo=AllocateImageMemory(Nx,Ny,(Nz+BITS-1)/BITS);
	curr=AllocateSliceMemory(Nx,Ny);
	prev=AllocateSliceMemory(Nx,Ny);
	succ=AllocateSliceMemory(Nx,Ny);

	x1=Nx; y1=Ny; z1=Nz; x2=y2=z2=(-1);
	for (z=0; z<Nz; z++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&curr);

	    cell=depo[z/BITS]; mask=(Cell)(1<<(z%BITS));
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++)
		if ((int)curr[y][x]>=lo && (int)curr[y][x]<=up) {
		    cell[y][x]|=mask; MM(x,x1,x2); MM(y,y1,y2); MM(z,z1,z2);
		}
	}
	if (x1>x2 || y1>y2 || z1>z2) Error(nop);

	for (t=0; t<thick; t++) {
	    RESTORE_CELL(z1);

	    x3=Nx; y3=Ny; z3=Nz; x4=y4=z4=(-1);
	    for (z=z1; z<=z2; z++) {
		cell=prev; prev=curr; curr=succ; succ=cell;
		if (z!=z2) {
		    RESTORE_CELL(z+1);
		}
		cell=depo[z/BITS]; mask=(Cell)(~(1<<(z%BITS)));
		for (y=y1; y<=y2; y++)
		for (x=x1; x<=x2; x++)
		    if (curr[y][x])
			if (z==z1 || !prev[y  ][x  ] ||
			    z==z2 || !succ[y  ][x  ] ||
			    y==y1 || !curr[y-1][x  ] ||
			    y==y2 || !curr[y+1][x  ] ||
			    x==x1 || !curr[y  ][x-1] ||
			    x==x2 || !curr[y  ][x+1])
			    cell[y][x]&=mask;
			else {
			    MM(x,x3,x4); MM(y,y3,y4); MM(z,z3,z4);
			}
	    }
	    if (x3>x4 || y3>y4 || z3>z4) Error(nop);

	    x1=x3; y1=y3; z1=z3; x2=x4; y2=y4; z2=z4;
	}
	while (--t>=0) {
	    --x1; --y1; --z1; ++x2; ++y2; ++z2;

	    for (y=y1; y<=y2; y++)
	    for (x=x1; x<=x2; x++) succ[y][x]=0;

	    x3=Nx; y3=Ny; z3=Nz; x4=y4=z4=(-1);
	    for (z=z1; z<=z2; z++) {
		cell=prev; prev=curr; curr=succ; succ=cell;
		if (z!=z2) {
		    RESTORE_CELL(z+1);
		}
		cell=depo[z/BITS]; mask=(Cell)(1<<(z%BITS));
		for (y=y1; y<=y2; y++)
		for (x=x1; x<=x2; x++)
		    if (curr[y][x]) {
			MM(x,x3,x4); MM(y,y3,y4); MM(z,z3,z4);
		    }
		    else
			if ((z!=z1 && prev[y  ][x  ]) ||
			    (z!=z2 && succ[y  ][x  ]) ||
			    (y!=y1 && curr[y-1][x  ]) ||
			    (y!=y2 && curr[y+1][x  ]) ||
			    (x!=x1 && curr[y  ][x-1]) ||
			    (x!=x2 && curr[y  ][x+1])) {
			    cell[y][x]|=mask;
			    MM(x,x3,x4); MM(y,y3,y4); MM(z,z3,z4);
			}
	    }
	    x1=x3; y1=y3; z1=z3; x2=x4; y2=y4; z2=z4;
	}
	for (z=0; z<Nz; z++) {
	    cell=depo[z/BITS]; mask=(Cell)(1<<(z%BITS));
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) curr[y][x]=(cell[y][x]&mask)?1:0;

	    StoreImageFile(argv[6],names+z,&curr,0,0,0,Nx-1,Ny-1,0,1,NULL,NULL);
	}
	return 0;
}
