
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "slice.h"

static double	DP[2][3],RM[3][3],MM[2][3],*Min=MM[0],*Max=MM[1];

static void	MinMax()
{
	int	j,k,l,m;
	double	dp0,dp1,dp2,*rm,mm;

	for (j=0; j<2; j++) { dp0=DP[j][0];
	for (k=0; k<2; k++) { dp1=DP[k][1];
	for (l=0; l<2; l++) { dp2=DP[l][2];
	for (m=0; m<3; m++) {
	    rm=RM[m]; mm=rm[0]*dp0+rm[1]*dp1+rm[2]*dp2;
	    if (j==0 && k==0 && l==0)
		Min[m]=Max[m]=mm;
	    else
		if (mm<Min[m]) Min[m]=mm; else
		if (mm>Max[m]) Max[m]=mm;
	}}}}
}

#define NUM	unsigned char

#ifndef	SUM
#define SUM	unsigned int
#endif

#define STR_LEN	1023

#define ALLOC(type,size)	(type *)malloc(sizeof(type)*(size_t)(size))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,BPS,none,Nh,Nv,Nd,d,v,h,x1,y1,z1,x2,y2,z2,
		Ix=2,Iy=2,Iz=2;
	char	**names,path[STR_LEN],form[STR_LEN],
		*bmae="bin memory allocation error.";
	double	x0,y0,z0,dx,dy,dz,hx,hy,hz,vx,vy,vz,h0,v0,d0,
		Mx=1.0,My=1.0,Mz=1.0;
	Cell	**cell;
	NUM	***num;
	SUM	***sum;

	if (argc!=11 && argc!=14 && argc!=17 && argc!=20)
	    Error("usage : sliceIRS orgDir name x0 y0 z0 dx dy dz {Mx My Mz}\n"
		  "                 none {h1 v1 d1 h2 v2 d2} newDir");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,&BPS,NULL);

	if (BPS+8*sizeof(NUM)>8*sizeof(SUM))
	    fputs("too many bits per sample (warning).\n",stderr);

	x0=atof(argv[3]); y0=atof(argv[4]); z0=atof(argv[5]);
	dx=atof(argv[6]); dy=atof(argv[7]); dz=atof(argv[8]);

	if (dx==0.0 && dy==0.0) {
	    if (dz==0.0) Error("bad axial vector.");

	    hx=1.0; vy=dz=(dz>0.0)?1.0:-1.0; hy=hz=vx=vz=0.0;
	}
	else
{
	double	xy=dx*dx+dy*dy,
		rxy=sqrt(xy),son=dy/rxy,con=dx/rxy,
		rxyz=sqrt(xy+dz*dz),sat=dz/rxyz,cat=rxy/rxyz;

	hx=(-son)    ; hy=  con     ; hz=0.0;
	vx=(-con)*sat; vy=(-son)*sat; vz=cat;
	dx=  con *cat; dy=  son *cat; dz=sat;
}
	if (argc==14 || argc==20) {
	    if ((Mx=atof(argv[ 9]))<=0.0 ||
		(My=atof(argv[10]))<=0.0 ||
		(Mz=atof(argv[11]))<=0.0 ||
		Mx*My*Mz*(double)(1<<8*sizeof(NUM))<=1.0)
		Error("bad magnification factor.");

	    Ix=(int)Mx+1; Iy=(int)My+1; Iz=(int)Mz+1;

	    none=atoi(argv[12]);
	}
	else
	    none=atoi(argv[ 9]);

	if (none<0 || none>=1<<BPS) Error("bad value of none.");

	DP[0][0]=Mx*(-x0); DP[1][0]=Mx*((double)Nx-x0);
	DP[0][1]=My*(-y0); DP[1][1]=My*((double)Ny-y0);
	DP[0][2]=Mz*(-z0); DP[1][2]=Mz*((double)Nz-z0);
	RM[0][0]=hx; RM[0][1]=hy; RM[0][2]=hz;
	RM[1][0]=vx; RM[1][1]=vy; RM[1][2]=vz;
	RM[2][0]=dx; RM[2][1]=dy; RM[2][2]=dz; MinMax();
{
	double	h1,v1,d1,h2,v2,d2;

	if (argc==17 || argc==20) {
	    if ((h1=atof(argv[argc-7]))>Max[0] ||
		(h2=atof(argv[argc-4]))<Min[0] || h1>h2 ||
		(v1=atof(argv[argc-6]))>Max[1] ||
		(v2=atof(argv[argc-3]))<Min[1] || v1>v2 ||
		(d1=atof(argv[argc-5]))>Max[2] ||
		(d2=atof(argv[argc-2]))<Min[2] || d1>d2)
		Error("bad area of rectangular parallelepiped.");
	}
	else {
	    h1=Min[0]; v1=Min[1]; d1=Min[2];
	    h2=Max[0]; v2=Max[1]; d2=Max[2];
	}
	h0=h1; Nh=(int)ceil(h2-h1);
	v0=v1; Nv=(int)ceil(v2-v1);
	d0=d1; Nd=(int)ceil(d2-d1);

	printf("%lg\t%lg\t%lg\n",-h0,-v0,-d0);

	DP[0][0]=h1; DP[1][0]=h2;
	DP[0][1]=v1; DP[1][1]=v2;
	DP[0][2]=d1; DP[1][2]=d2;
}
	RM[0][0]=hx; RM[0][1]=vx; RM[0][2]=dx;
	RM[1][0]=hy; RM[1][1]=vy; RM[1][2]=dy;
	RM[2][0]=hz; RM[2][1]=vz; RM[2][2]=dz; MinMax();
	Min[0]=Min[0]/Mx+x0; x1=(Min[0]<0)?0:(int)Min[0];
	Min[1]=Min[1]/My+y0; y1=(Min[1]<0)?0:(int)Min[1];
	Min[2]=Min[2]/Mz+z0; z1=(Min[2]<0)?0:(int)Min[2];
	Max[0]=Max[0]/Mx+x0; x2=(Max[0]>=(double)Nx)?Nx-1:(int)Max[0];
	Max[1]=Max[1]/My+y0; y2=(Max[1]>=(double)Ny)?Ny-1:(int)Max[1];
	Max[2]=Max[2]/Mz+z0; z2=(Max[2]>=(double)Nz)?Nz-1:(int)Max[2];

	cell=AllocateSliceMemory((Nx>Nh)?Nx:Nh,(Ny>Nv)?Ny:Nv);

	if ((num=ALLOC(NUM **,Nd))==NULL ||
	    (sum=ALLOC(SUM **,Nd))==NULL) Error(bmae);

	for (d=0; d<Nd; d++) {
	    if ((num[d]=ALLOC(NUM *,Nv))==NULL ||
		(sum[d]=ALLOC(SUM *,Nv))==NULL) Error(bmae);

	    for (v=0; v<Nv; v++) {
		if ((num[d][v]=ALLOC(NUM,Nh))==NULL ||
		    (sum[d][v]=ALLOC(SUM,Nh))==NULL) Error(bmae);

		for (h=0; h<Nh; h++) sum[d][v][h]=num[d][v][h]=0;
	    }
	}
{
	int	nz,ny,nx,iz,iy,ix;
	Cell	c;
	double	z,hz0,vz0,dz0,y,hyz0,vyz0,dyz0,x;

	for (nz=z1; nz<=z2; nz++) {
	    ReadImageFile(argv[1],names+nz,Nx,Ny,1,&cell);

	    for (ny=y1; ny<=y2; ny++)
	    for (nx=x1; nx<=x2; nx++) {
		c=cell[ny][nx];
	
		for (iz=0; iz<Iz; iz++) {
		    z=Mz*((double)nz+((double)iz+0.5)/(double)Iz-z0);
		    hz0=hz*z-h0; vz0=vz*z-v0; dz0=dz*z-d0;
		    for (iy=0; iy<Iy; iy++) {
			y=My*((double)ny+((double)iy+0.5)/(double)Iy-y0);
			hyz0=hy*y+hz0; vyz0=vy*y+vz0; dyz0=dy*y+dz0;
			for (ix=0; ix<Ix; ix++) {
			    x=Mx*((double)nx+((double)ix+0.5)/(double)Ix-x0);
			    if ((h=(int)(hx*x+hyz0))>=0 && h<Nh &&
				(v=(int)(vx*x+vyz0))>=0 && v<Nv &&
				(d=(int)(dx*x+dyz0))>=0 && d<Nd) {
				++num[d][v][h]; sum[d][v][h]+=c;
			    }
			}
		    }
		}
	    }
	}
}
	sprintf(path,"%d",Nd-1);
	sprintf(form,"%s/%%0%dd.tif",argv[argc-1],(int)strlen(path));

	for (d=0; d<Nd; d++) {
	    for (v=0; v<Nv; v++)
	    for (h=0; h<Nh; h++)
		if (num[d][v][h])
		    cell[v][h]=(Cell)((double)sum[d][v][h]/
				      (double)num[d][v][h]+0.5);
		else
		    cell[v][h]=(Cell)none;

	    sprintf(path,form,d);
	    StoreSliceFile(path,cell,0,0,Nh-1,Nv-1,BPS,NULL);
	}
	return 0;
}
