
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

#define STR_LEN	256

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,x1,y1,z1,x2,y2,z2,str_len,z;
	char	**names,**descs,format[STR_LEN];
	Cell	**cell;

	if (argc!=10)
	    Error("usage : sliceIT orgDir nameFile x1 y1 z1 x2 y2 z2 newDir");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,&descs);

	if ((x1=atoi(argv[3]))<0 || (x2=atoi(argv[6]))>=Nx || x1>x2 ||
	    (y1=atoi(argv[4]))<0 || (y2=atoi(argv[7]))>=Ny || y1>y2 ||
	    (z1=atoi(argv[5]))<0 || (z2=atoi(argv[8]))>=Nz || z1>z2)
	    Error("bad image trimming area.");

	cell=AllocateSliceMemory(Nx,Ny);

	for (str_len=1, z=z2-z1; z>=10; z/=10, str_len++) ;
	sprintf(format,"%%0%dd.tif",str_len);
 
	for (z=z1; z<=z2; z++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&cell);

	    sprintf(names[z],format,z-z1);
	    StoreImageFile(argv[9],names+z,&cell,x1,y1,0,x2,y2,0,
			   GetImageBPS(&cell,x1,y1,0,x2,y2,0),descs+z,NULL);
	}
	return 0;
}
