
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

static int	xSize,ySize,zSize;
static Cell	***cell;

static void	PrintCell(x,y,z)
double		x,y,z;
{
	int	h,v,d;

	if (x>=(-0.5) && x<(double)xSize-0.5 &&
	    y>=(-0.5) && y<(double)ySize-0.5 &&
	    z>=(-0.5) && z<(double)zSize-0.5) {
	    h=(int)(x+0.5);
	    v=(int)(y+0.5);
	    d=(int)(z+0.5); printf("%d\t%d\t%d\t%d\n",h,v,d,cell[d][v][h]);
	}
}

static void	ScanCell(x1,y1,z1,x2,y2,z2)
int		x1,y1,z1,x2,y2,z2;
{
	int	t,d=0,dx=x2-x1,dy=y2-y1,dz=z2-z1;
	double	r1,r2;

	if (dx>0) { if (dx>d) d=dx; } else if (-dx>d) d=(-dx);
	if (dy>0) { if (dy>d) d=dy; } else if (-dy>d) d=(-dy);
	if (dz>0) { if (dz>d) d=dz; } else if (-dz>d) d=(-dz);

	if (d)
	    for (t=0; t<=d; t++) {
		r1=(double)t/(double)d; r2=1.0-r1;
		PrintCell(r1*(double)x2+r2*(double)x1,
			  r1*(double)y2+r2*(double)y1,
			  r1*(double)z2+r2*(double)z1);
	    }
	else
	    PrintCell((double)x1,(double)y1,(double)z1);
}

#define LINE_LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	x1,y1,z1,x2,y2,z2;
	char	**names,line[LINE_LEN];

	if (argc!=3 && argc!=6 && argc!=9)
	Error("usage : sliceLP directory nameFile {x y z}|{x1 y1 z1 x2 y2 z2}");

	ScanNameFile(argv[1],argv[2],&zSize,&names);
	CheckImageFile(argv[1],zSize,names,&xSize,&ySize,NULL,NULL);
	cell=AllocateImageMemory(xSize,ySize,zSize);
	ReadImageFile(argv[1],names,xSize,ySize,zSize,cell);

	switch(argc) {
	    case 3 :
		while (fgets(line,LINE_LEN,stdin)!=NULL)
		    switch(sscanf(line,"%d %d %d %d %d %d",
				       &x1,&y1,&z1,&x2,&y2,&z2)) {
			case 3 :
			    ScanCell(x1,y1,z1,x1,y1,z1); break;
			case 6 :
			    ScanCell(x1,y1,z1,x2,y2,z2); break;
		    }
		break;
	    case 6 :
		x1=atoi(argv[3]);
		y1=atoi(argv[4]);
		z1=atoi(argv[5]); ScanCell(x1,y1,z1,x1,y1,z1); break;
	    case 9 :
		x1=atoi(argv[3]);
		y1=atoi(argv[4]);
		z1=atoi(argv[5]);
		x2=atoi(argv[6]);
		y2=atoi(argv[7]);
		z2=atoi(argv[8]); ScanCell(x1,y1,z1,x2,y2,z2); break;
	}
	return 0;
}
