
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,bps,N1,**Cx,**Cy,**Cz,i,j,z,x,y;
	char	**names,*cmae="counter memory allocation error.";
	Cell	**cell,**last;

	if (argc!=3) Error("usage : sliceMIC directory nameFile");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,&bps,NULL);

	N1=(1<<bps)-1;
	if ((Cx=(int **)malloc(N1*sizeof(*Cx)))==NULL ||
	    (Cy=(int **)malloc(N1*sizeof(*Cy)))==NULL ||
	    (Cz=(int **)malloc(N1*sizeof(*Cz)))==NULL) Error(cmae);

	for (i=0; i<N1; i++) {
	    if ((Cx[i]=(int *)calloc(N1-i,sizeof(**Cx)))==NULL ||
		(Cy[i]=(int *)calloc(N1-i,sizeof(**Cy)))==NULL ||
		(Cz[i]=(int *)calloc(N1-i,sizeof(**Cz)))==NULL) Error(cmae);

	    j=i+1; Cx[i]-=j; Cy[i]-=j; Cz[i]-=j;
	}
	cell=AllocateSliceMemory(Nx,Ny);
	last=AllocateSliceMemory(Nx,Ny);

	for (z=0; z<Nz; z++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&cell);

	    for (y=0; y<Ny; y++) for (i=(int)cell[y][0], x=1; x<Nx; x++, i=j) {
		j=(int)cell[y][x]; if (i<j) ++Cx[i][j]; else
				   if (i>j) ++Cx[j][i];
	    }
	    for (x=0; x<Nx; x++) for (i=(int)cell[0][x], y=1; y<Ny; y++, i=j) {
		j=(int)cell[y][x]; if (i<j) ++Cy[i][j]; else
				   if (i>j) ++Cy[j][i];
	    }
	    for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) {
		if (z) {
		    i=(int)last[y][x];
		    j=(int)cell[y][x]; if (i<j) ++Cz[i][j]; else
				       if (i>j) ++Cz[j][i];
		}
		last[y][x]=cell[y][x];
	    }
	}
	for (i=0; i<N1; i++) for (j=i+1; j<=N1; j++)
	    printf("%d\t%d\t%d\t%d\t%d\n",i,j,Cx[i][j],Cy[i][j],Cz[i][j]);

	return 0;
}
