
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "slice.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	lo,up,Nz,Nx,Ny,z,x,y,N1,N2;
	char	**names;
	Cell	**cell;
	double	N,xO,yO,Sxx,Syy,Sxy,X,Y,t,c,s,cc,ss,cs,La,Lb,tmp,A,B,a,b;

	if (argc!=5 && argc!=6)
	    Error("usage : sliceOF2 orgDir name lower upper {newDir}");

	if ((lo=atoi(argv[3]))>
	    (up=atoi(argv[4]))) Error("bad pixel value range.");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,NULL);
	cell=AllocateSliceMemory(Nx,Ny);

	for (z=0; z<Nz; z++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&cell);

	    N=xO=yO=Sxx=Syy=Sxy=0.0;
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++)
		if (cell[y][x]>=lo && cell[y][x]<=up) {
		    cell[y][x]=1; N+=1.0; X=(double)x; xO+=X; Sxx+=(X*X);
					  Y=(double)y; yO+=Y; Syy+=(Y*Y);
							      Sxy+=(X*Y);
		}
		else
		    cell[y][x]=0;

	    printf("%d\t%d",z,(int)N);

	    if (N>0.0) {
		xO/=N; Sxx-=(N*(xO*xO-1.0/12.0));
		yO/=N; Syy-=(N*(yO*yO-1.0/12.0)); Sxy-=(N*xO*yO);

		t=atan2(2.0*Sxy,Sxx-Syy)/2.0;

		c=cos(t); cc=c*c;
		s=sin(t); ss=s*s; cs=2.0*Sxy*c*s;
		if ((La=Sxx*ss+Syy*cc-cs)
#ifdef	OBLATE
		    >
#else
		    <
#endif
		    (Lb=Sxx*cc+Syy*ss+cs)) {
		    t-=(M_PI/2.0);
		    tmp=c; c=s; s=(-tmp);
		    tmp=La; La=Lb; Lb=tmp;
		}
		A=sqrt(4.0*Lb/N);
		B=sqrt(4.0*La/N);

		N1=N2=0;
		for (y=0; y<Ny; y++) { Y=(double)y-yO;
		for (x=0; x<Nx; x++) { X=(double)x-xO;
		    a=(X*c+Y*s)/A;
		    b=(Y*c-X*s)/B;
		    if (a*a+b*b<=1.0) {
			++N1; if ((cell[y][x]+=2)==3) ++N2;
		    }
		}}
		printf("\t%lg\t%lg\t%lg\t%lg\t%lg\t%d\t%d",
		       xO,yO,((t<0.0)?t+M_PI:t)*180.0/M_PI,A,B,N1,N2);
	    }
	    putchar('\n');

	    if (argc==6)
	    StoreImageFile(argv[5],names+z,&cell,0,0,0,Nx-1,Ny-1,0,2,NULL,NULL);
	}
	return 0;
}
