
/*
	octarant label (for ovoid)
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "slice.h"

static int	PZM(x1,y1,z1,x2,y2,z2)
double		x1,y1,z1,x2,y2,z2;
{
	double	xyz=x1+y1+z1,min=xyz,max=xyz;

	xyz=x1+y1+z2; if (xyz<min) min=xyz; if (xyz>max) max=xyz;
	xyz=x1+y2+z1; if (xyz<min) min=xyz; if (xyz>max) max=xyz;
	xyz=x1+y2+z2; if (xyz<min) min=xyz; if (xyz>max) max=xyz;
	xyz=x2+y1+z1; if (xyz<min) min=xyz; if (xyz>max) max=xyz;
	xyz=x2+y1+z2; if (xyz<min) min=xyz; if (xyz>max) max=xyz;
	xyz=x2+y2+z1; if (xyz<min) min=xyz; if (xyz>max) max=xyz;
	xyz=x2+y2+z2; if (xyz<min) min=xyz; if (xyz>max) max=xyz;

	return (min>0.0)?2:(max<0.0)?0:1;
}

#define FORMAT_LEN	512
#define RADIAN		(M_PI/180.0)
#define BPS		8

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,z,length,y,x;
	char	**names,format[FORMAT_LEN],**descs=NULL,
		*nmae="name memory allocation error.";
	Cell	**cell;
	double	x0,y0,z0,lon,lat,rot,
		cLon,sLon,cLat,sLat,cRot,sRot,xa,xb,xc,ya,yb,yc,za,zb,zc,xyz,
		az1,bz1,cz1,az2,bz2,cz2,
		ay1,by1,cy1,ay2,by2,cy2,
		ax1,bx1,cx1,ax2,bx2,cx2,Sx=1.0,Sy=1.0,Sz=1.0;

	if (argc!=10 && argc!=11 && argc!=13 && argc!=14)
	    Error(
"usage : sliceOL (org name)|(Nx Ny Nz) {Sx Sy Sz} x0 y0 z0 lon lat rot new"
	    );

	if (argc==10 || argc==13) {
	    ScanNameFile(argv[1],argv[2],&Nz,&names);
	    CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,&descs);
	}
	else {
	    if ((Nx=atoi(argv[1]))<=0 ||
		(Ny=atoi(argv[2]))<=0 ||
		(Nz=atoi(argv[3]))<=0) Error("bad image size.");

	    if ((names=(char **)malloc(Nz*sizeof(*names)))==NULL) Error(nmae);

	    for (length=1, z=10; z<Nz; z*=10, length++);
	    sprintf(format,"%%0%dd.tif",length);
	    length+=5; /* ".tif\0" */

	    for (z=0; z<Nz; z++) {
		if ((names[z]=(char *)malloc(length))==NULL) Error(nmae);

		sprintf(names[z],format,z);
	    }
	}
	cell=AllocateSliceMemory(Nx,Ny);

	if (argc==13 || argc==14)
	    if ((Sx=atof(argv[argc-10]))<=0.0 ||
		(Sy=atof(argv[argc- 9]))<=0.0 ||
		(Sz=atof(argv[argc- 8]))<=0.0) Error("bad scaling factor.");

	x0=atof(argv[argc-7])/Sx;
	y0=atof(argv[argc-6])/Sy;
	z0=atof(argv[argc-5])/Sz;

	lon=atof(argv[argc-4])*RADIAN; cLon=cos(lon); sLon=sin(lon);
	lat=atof(argv[argc-3])*RADIAN; cLat=cos(lat); sLat=sin(lat);
	rot=atof(argv[argc-2])*RADIAN; cRot=cos(rot); sRot=sin(rot);

	xa=( sLon*cRot+cLon*sLat*sRot)*Sx;
	xb=(-sLon*sRot+cLon*sLat*cRot)*Sx;
	xc=	       cLon*cLat      *Sx;
	ya=(-cLon*cRot+sLon*sLat*sRot)*Sy;
	yb=( cLon*sRot+sLon*sLat*cRot)*Sy;
	yc=	       sLon*cLat      *Sy;
	za=		   -cLat*sRot *Sz;
	zb=		   -cLat*cRot *Sz;
	zc=		    sLat      *Sz;

	xyz=(-0.5-z0); az1=za*xyz; bz1=zb*xyz; cz1=zc*xyz;
	for (z=0; z<Nz; z++) {
	    xyz=(double)z+0.5-z0; az2=za*xyz; bz2=zb*xyz; cz2=zc*xyz;
	    xyz=(-0.5-y0); ay1=ya*xyz; by1=yb*xyz; cy1=yc*xyz;
	    for (y=0; y<Ny; y++) {
		xyz=(double)y+0.5-y0; ay2=ya*xyz; by2=yb*xyz; cy2=yc*xyz;
		xyz=(-0.5-x0); ax1=xa*xyz; bx1=xb*xyz; cx1=xc*xyz;
		for (x=0; x<Nx; x++) {
		    xyz=(double)x+0.5-x0; ax2=xa*xyz; bx2=xb*xyz; cx2=xc*xyz;

		    cell[y][x]=(Cell)(PZM(ax1,ay1,az1,ax2,ay2,az2)*9+
				      PZM(bx1,by1,bz1,bx2,by2,bz2)*3+
				      PZM(cx1,cy1,cz1,cx2,cy2,cz2)+1);

		    ax1=ax2; bx1=bx2; cx1=cx2;
		}
		ay1=ay2; by1=by2; cy1=cy2;
	    }
	    az1=az2; bz1=bz2; cz1=cz2;

	    StoreImageFile(argv[argc-1],names+z,&cell,0,0,0,Nx-1,Ny-1,0,BPS,
			  (descs!=NULL)?descs+z:NULL,NULL);
	}
	return 0;
}
