
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	zSize,xSize,ySize,bg,x,y,z;
	char	**names,**descs;
	Cell	**cell,**mask;

	if (argc!=6)
	    Error("usage : slicePVM maskDir nameFile back foreDir newDir");

	ScanNameFile(argv[1],argv[2],&zSize,&names);
	CheckImageFile(argv[1],zSize,names,&xSize,&ySize,NULL,NULL);
	CheckImageFile(argv[4],zSize,names,&x,&y,NULL,&descs);
	if (xSize!=x || ySize!=y) Error("bad foreground image size.");

	if ((bg=atoi(argv[3]))<0) Error("bad background pixel value.");

	cell=AllocateSliceMemory(xSize,ySize);
	mask=AllocateSliceMemory(xSize,ySize);

	for (z=0; z<zSize; z++) {
	    ReadImageFile(argv[4],names+z,xSize,ySize,1,&cell);
	    ReadImageFile(argv[1],names+z,xSize,ySize,1,&mask);

	    for (y=0; y<ySize; y++)
	    for (x=0; x<xSize; x++) if (!mask[y][x]) cell[y][x]=(Cell)bg;

	    StoreImageFile(argv[5],names+z,&cell,0,0,0,xSize-1,ySize-1,0,
			   GetImageBPS(&cell,0,0,0,xSize-1,ySize-1,0),
			   descs+z,NULL);
	}
	return 0;
}
