
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

#define LIMIT	(1<<(8*sizeof(Cell)))

static void	ReplacePixelValue(xSize,ySize,cell,lut,cnt)
int		xSize,ySize,*cnt;
Cell		**cell,*lut;
{
	int	x,y,pv;

	for (y=0; y<ySize; y++)
	for (x=0; x<xSize; x++) {
	    pv=cell[y][x]; cell[y][x]=lut[pv]; ++(cnt[pv]);
	}
}

#define STR_LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	zSize,xSize,ySize,*cnt,idx,o1,o2,n1,n2,d,z;
	char	**names,**descs,line[STR_LEN];
	Cell	**cell,*lut;

	if (argc!=3 && argc!=4)
	    Error("usage : slicePVR orgDir nameFile {newDir}");

	ScanNameFile(argv[1],argv[2],&zSize,&names);
	CheckImageFile(argv[1],zSize,names,&xSize,&ySize,NULL,&descs);

	cell=AllocateSliceMemory(xSize,ySize);

	if ((lut=(Cell *)malloc(LIMIT*sizeof(*lut)))==NULL ||
	    (cnt=(int  *)malloc(LIMIT*sizeof(*cnt)))==NULL)
	    Error("replacement memory allocation error.");

	for (idx=0; idx<LIMIT; idx++) { lut[idx]=(Cell)idx; cnt[idx]=0; }

	while (fgets(line,STR_LEN,stdin)!=NULL) {
	    switch(sscanf(line,"%d %d %d %d",&o1,&o2,&n1,&n2)) {
		case 2  : n1=n2=o2; o2=o1; break;
		case 3  : n2=n1; break;
		case 4  : break;
		default : continue;
	    }
	    if (o1>=0 && o2<LIMIT && o1<=o2 && n1>=0 && n1<LIMIT &&
					       n2>=0 && n2<LIMIT)
		if ((d=o2-o1)==0)
		    lut[o1]=(Cell)n1;
		else
		    for (idx=o1; idx<=o2; idx++)
			lut[idx]=(Cell)(((double)n1*(double)(o2-idx)+
					 (double)n2*(double)(idx-o1))
					/(double)d+0.5);
	}

	for (z=0; z<zSize; z++) {
	    ReadImageFile(argv[1],names+z,xSize,ySize,1,&cell);

	    ReplacePixelValue(xSize,ySize,cell,lut,cnt);

	    if (argc==4)
		StoreImageFile(argv[3],names+z,&cell,0,0,0,xSize-1,ySize-1,0,
			       GetImageBPS(&cell,0,0,0,xSize-1,ySize-1,0),
			       descs+z,NULL);
	}

	for (idx=0; idx<LIMIT; idx++)
	    if (cnt[idx]) printf("%d\t%d\t%d\n",idx,lut[idx],cnt[idx]);

	return 0;
}
