
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "slice.h"

#define IPV	(int)cell[y][x]
#define DPV	(double)cell[y][x]

static void	CheckPixelValueRange(x1,y1,x2,y2,cell,lo,up,
				     no,min,max,mean,SD)
int		x1,y1,x2,y2,lo,up,*no,*min,*max;
Cell		**cell;
double		*mean,*SD;
{
	int	x,y;

	for (y=y1; y<=y2; y++)
	for (x=x1; x<=x2; x++)
	    if (IPV>=lo && IPV<=up) {
		++(*no); if (IPV<*min) *min=IPV;
			 if (IPV>*max) *max=IPV; *mean+=DPV; *SD+=(DPV*DPV);
	    }
}

#define LIMIT	((1<<(8*sizeof(Cell)))-1)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	zSize,xSize,ySize,x1,y1,z1,x2,y2,z2,lo,up,no,min,max,z;
	char	**names;
	Cell	**cell;
	double	mean,SD;

	if (argc!=3 && argc!=5 && argc!=9 && argc!=11)
Error("usage : slicePVRC dir. nameFile {x1 y1 z1 x2 y2 z2} {lower upper}");

	ScanNameFile(argv[1],argv[2],&zSize,&names);
	CheckImageFile(argv[1],zSize,names,&xSize,&ySize,NULL,NULL);

	cell=AllocateSliceMemory(xSize,ySize);

	switch(argc) {
	    case 3 :
		x1=y1=z1=0; x2=xSize-1; y2=ySize-1; z2=zSize-1;
		lo=0; up=LIMIT;
		break;
	    case 5 :
		x1=y1=z1=0; x2=xSize-1; y2=ySize-1; z2=zSize-1;
		lo=atoi(argv[3]); up=atoi(argv[4]);
		break;
	    case 9 :
		x1=atoi(argv[3]); y1=atoi(argv[4]); z1=atoi(argv[5]);
		x2=atoi(argv[6]); y2=atoi(argv[7]); z2=atoi(argv[8]);
		lo=0; up=LIMIT;
		break;
	    case 11 :
		x1=atoi(argv[3]); y1=atoi(argv[ 4]); z1=atoi(argv[5]);
		x2=atoi(argv[6]); y2=atoi(argv[ 7]); z2=atoi(argv[8]);
		lo=atoi(argv[9]); up=atoi(argv[10]);
		break;
	}
	if (x1<0 || x1>x2 || x2>=xSize ||
	    y1<0 || y1>y2 || y2>=ySize ||
	    z1<0 || z1>z2 || z2>=zSize) Error("bad cell area.");

	if (lo<0 || lo>up || up>LIMIT) Error("bad pixel value range.");

	no=0; min=up; max=lo; mean=SD=0.0;

	for (z=z1; z<=z2; z++) {
	    ReadImageFile(argv[1],names+z,xSize,ySize,1,&cell);

	    CheckPixelValueRange(x1,y1,x2,y2,cell,lo,up,
				 &no,&min,&max,&mean,&SD);
	}

	if (no) {
	    mean/=(double)no; SD=sqrt(SD/(double)no-mean*mean);
	}

	printf("%d",no);
	if (no)
	    printf("\t%d\t%d\t%lg\t%lg\n",min,max,mean,SD);
	else
	    puts("\t0\t0\t0\t0");

	return 0;
}
