
#include <stdio.h>
#include <stdlib.h>
#include "slice.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,bps,pv,N,*Cx,*Cy,*Cz,z,x,y,n;
	char	**names;
	Cell	**cell,**last,k,i,j;

	if (argc!=4) Error("usage : sliceSIC directory nameFile pixelValue");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,&bps,NULL);

	if ((pv=atoi(argv[3]))<0 || pv>=(N=1<<bps)) Error("bad pixel value.");

	if ((Cx=(int *)calloc(N,sizeof(*Cx)))==NULL ||
	    (Cy=(int *)calloc(N,sizeof(*Cy)))==NULL ||
	    (Cz=(int *)calloc(N,sizeof(*Cz)))==NULL)
	    Error("counter memory allocation error.");

	cell=AllocateSliceMemory(Nx,Ny);
	last=AllocateSliceMemory(Nx,Ny);

	k=(Cell)pv;

	for (z=0; z<Nz; z++) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&cell);

	    for (y=0; y<Ny; y++) for (i=cell[y][0], x=1; x<Nx; x++, i=j) {
		j=cell[y][x]; if (i==k) ++Cx[j]; else if (j==k) ++Cx[i];
	    }
	    for (x=0; x<Nx; x++) for (i=cell[0][x], y=1; y<Ny; y++, i=j) {
		j=cell[y][x]; if (i==k) ++Cy[j]; else if (j==k) ++Cy[i];
	    }
	    for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) {
		if (z)
		    if (last[y][x]==k) ++Cz[cell[y][x]]; else
		    if (cell[y][x]==k) ++Cz[last[y][x]];

		last[y][x]=cell[y][x];
	    }
	}
	for (n=0; n<N; n++)
	    printf("%d\t%d\t%d\t%d\t%d\n",pv,n,Cx[n],Cy[n],Cz[n]);

	return 0;
}
