
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "slice.h"

#define STR_LEN		512

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,Mx,My,Mz,Lx,Ly,z,z0,y,y0,x,x0,j,i,bps,k;
	char	**names,*name[1],path[STR_LEN],format[STR_LEN],
		*bmop="bad multiple of pixels.";
	Cell	**org,**new,pv;

	if (argc!=5 && argc!=7)
	    Error("usage : sliceSIM org name multiple|(Mx My Mz) new");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,NULL);

	if (argc==5) {
	    if ((Mx=My=Mz=atoi(argv[3]))<=0) Error(bmop);
	}
	else
	    if ((Mx=atoi(argv[3]))<=0 ||
		(My=atoi(argv[4]))<=0 ||
		(Mz=atoi(argv[5]))<=0) Error(bmop);

	Lx=Mx*Nx;
	Ly=My*Ny;

	org=AllocateSliceMemory(Nx,Ny);
	new=AllocateSliceMemory(Lx,Ly);

	name[0]=path;
	sprintf(*name,"%d",Mz*Nz-1);
	sprintf(format,"%%0%dd.tif",strlen(*name));

	for (z0=z=0; z<Nz; z++, z0+=Mz) {
	    ReadImageFile(argv[1],names+z,Nx,Ny,1,&org);

	    for (y0=y=0; y<Ny; y++, y0+=My)
	    for (x0=x=0; x<Nx; x++, x0+=Mx) {
		pv=org[y][x];
		for (j=0; j<My; j++)
		for (i=0; i<Mx; i++) new[y0+j][x0+i]=pv;
	    }
	    bps=GetImageBPS(&org,0,0,0,Nx-1,Ny-1,0);

	    for (k=0; k<Mz; k++) {
		sprintf(*name,format,z0+k);
		StoreImageFile(argv[argc-1],name,&new,0,0,0,Lx-1,Ly-1,0,bps,
			       NULL,NULL);
	    }
	}
	return 0;
}
