
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "slice.h"

static int	Pixels(arg,Nxyz)
char		*arg;
int		Nxyz;
{
	int	Nhvd=(*arg!='-')?(int)ceil(atof(arg)*(double)Nxyz):-atoi(arg);

	if (Nhvd<Nxyz) Error("bad (multiple of) pixels.");

	return Nhvd;
}

#define STR_LEN		512

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nz,Nx,Ny,Nh,Nv,Nd,y,z,d,x,v,h;
	char	**names,*name[1],path[STR_LEN],format[STR_LEN];
	double	m,xh,yv,zd,rz,ry,rx;
	Cell	**old,**now,**cell,**tmp;

	if (argc!=5 && argc!=7)
	Error("usage : sliceTLI org name multiple|(Mx|-Nx My|-Ny Mz|-Nz) new");

	ScanNameFile(argv[1],argv[2],&Nz,&names);
	CheckImageFile(argv[1],Nz,names,&Nx,&Ny,NULL,NULL);

	if (argc==5) {
	    if ((m=atof(argv[3]))<1.0) Error("bad multiple of pixels.");

	    Nh=(int)ceil(m*(double)Nx);
	    Nv=(int)ceil(m*(double)Ny);
	    Nd=(int)ceil(m*(double)Nz);
	}
	else {
	    Nh=Pixels(argv[3],Nx);
	    Nv=Pixels(argv[4],Ny);
	    Nd=Pixels(argv[5],Nz);
	}
	xh=(double)Nx/(double)Nh;
	yv=(double)Ny/(double)Nv;
	zd=(double)Nz/(double)Nd;

	old=AllocateSliceMemory(Nx+2,Ny+2)+1;
	now=AllocateSliceMemory(Nx+2,Ny+2)+1;
	for (y=(-1); y<=Ny; y++) {
	    ++old[y]; ++now[y];
	}
	cell=AllocateSliceMemory(Nh,Nv);

	name[0]=path;
	sprintf(*name,"%d",Nd-1);
	sprintf(format,"%%0%dd.tif",strlen(*name));

	for (z=(-1), d=0; d<Nd; d++) {
	    if ((rz=zd*((double)d+0.5)+0.5-(double)z)>=1.0) {
		++z, rz-=1.0;

		tmp=old; old=now; now=tmp;
		if (z==Nz)
		    for (y=0; y<Ny; y++)
		    for (x=0; x<Nx; x++) now[y][x]=0;
		else
		    ReadImageFile(argv[1],names+z,Nx,Ny,1,&now);
	    }
	    for (y=(-1), v=0; v<Nv; v++) {
		if ((ry=yv*((double)v+0.5)+0.5-(double)y)>=1.0) {
		    ++y; ry-=1.0;
		}
		for (x=(-1), h=0; h<Nh; h++) {
		    if ((rx=xh*((double)h+0.5)+0.5-(double)x)>=1.0) {
			++x; rx-=1.0;
		    }

#define V000	(double)old[y-1][x-1]
#define V001	(double)now[y-1][x-1]
#define V010	(double)old[y][x-1]
#define V011	(double)now[y][x-1]
#define V100	(double)old[y-1][x]
#define V101	(double)now[y-1][x]
#define V110	(double)old[y][x]
#define V111	(double)now[y][x]

		    cell[v][h]=(Cell)floor((V111-V110-V101+V100
					   -V011+V010+V001-V000)*rx*ry*rz
					  +(V110-V100-V010+V000)*rx*ry
					  +(V011-V010-V001+V000)*ry*rz
					  +(V101-V100-V001+V000)*rz*rx
					  +(V100-V000)*rx
					  +(V010-V000)*ry
					  +(V001-V000)*rz
					  + V000+0.5);
		}
	    }
	    sprintf(*name,format,d);
	    StoreImageFile(argv[argc-1],name,&cell,0,0,0,Nh-1,Nv-1,0,
			   GetImageBPS(&cell,0,0,0,Nh-1,Nv-1,0),NULL,NULL);
	}
	return 0;
}
