
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tiffio.h"
#include "copysl.h"

extern void	CopyTAGControl(),CopyTAG();

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

#define STRLEN	256

static char	*GetDesc(file)
FILE		*file;
{
	int	len,tot=0;
	char	str[STRLEN+1],*ptr,*desc;

	do {
	    len=fread(str,1,STRLEN,file); str[len]='\0';

	    if ((ptr=(char *)malloc(tot+len+1))==NULL)
		Error("description memory not allocated.");

	    if (tot==0)
		strcpy(ptr,str);
	    else {
		strcpy(ptr,desc); strcat(ptr,str); free(desc);
	    }
	    desc=ptr; tot+=len;
	} while (len==STRLEN);

	return(desc);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	TIFF	*org,*new;
	char	*desc,*msg;
	int	len;

	if (argc!=2 && argc!=4)
	    Error("usage : tiffdesc TIFF {description newTIFF}");

	if ((org=TIFFOpen(argv[1],"r"))==NULL) Error("TIFF file not found.");

	if (argc==2)
{
	if (TIFFGetField(org,TIFFTAG_IMAGEDESCRIPTION,&desc)) {
	    if ((len=strlen(desc))!=0 && desc[len-1]=='\n') desc[len-1]='\0';

	    puts(desc);
	}
}
	else
{
	if ((new=TIFFOpen(argv[3],"w"))==NULL) Error("TIFF file not created.");

	CopyTAGControl(TIFFTAG_IMAGEDESCRIPTION,0); CopyTAG(org,new);

	if ((len=strlen(argv[2]))!=0)
	    if (len==1 && argv[2][0]=='-')
		TIFFSetField(new,TIFFTAG_IMAGEDESCRIPTION,GetDesc(stdin));
	    else
		TIFFSetField(new,TIFFTAG_IMAGEDESCRIPTION,argv[2]);

	if ((msg=CopyScanline(org,new))!=NULL) Error(msg);

	TIFFClose(new);
}
	TIFFClose(org); return(0);
}
