
#include <stdio.h>
#include <stdlib.h>
#include "tiffio.h"
#include "copysl.h"

extern void	CopyTAG();

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

#define STRLEN	256

int	main(argc,argv)
int	argc;
char	**argv;
{
	TIFF	*org,*new;
	char	*msg;

	if (argc!=3) Error("usage : tifflzw orgTIFF newTIFF");

	if ((org=TIFFOpen(argv[1],"r"))==NULL) Error("TIFF file not found.");

	if ((new=TIFFOpen(argv[2],"w"))==NULL) Error("TIFF file not created.");

	CopyTAG(org,new);
{
	int32	tss=TIFFScanlineSize(org);

	TIFFSetField(new,TIFFTAG_ROWSPERSTRIP,(tss>8192)?(int32)1:
							 (int32)(8192/tss));
}
	TIFFSetField(new,TIFFTAG_COMPRESSION,(int16)COMPRESSION_LZW);

	if ((msg=CopyScanline(org,new))!=NULL) Error(msg);

	TIFFClose(new); TIFFClose(org); return(0);
}
