
#include <stdio.h>
#include <stdlib.h>
#include "tiffio.h"

#define ERROR(msg)	fputs(msg,stderr); fputc('\n',stderr)

static void	Error(msg)
char		*msg;
{
	ERROR(msg); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	TIFF	*tiff;
	uint16	spp;

	if (argc!=2) Error("usage : tiffspp TIFF");

	if ((tiff=TIFFOpen(argv[1],"r"))==NULL) Error("TIFF file not found.");

	if (!TIFFGetField(tiff,TIFFTAG_SAMPLESPERPIXEL,&spp)) {
	    ERROR("no image samples per pixel description.");

	    TIFFGetFieldDefaulted(tiff,TIFFTAG_SAMPLESPERPIXEL,&spp);
	}
	printf("%d\n",(int)spp); return 0;
}
